#Generate Table IX of the Paper
library(fossil)
library(dbscan)
library(dplyr)
a=read.csv("./Datasets/hydropower.csv",header=TRUE)
b=a[,-c(1)]
source('./Codes/hydroLoMST.r')
f=hydroLoMST(15,b)
a$score=f$compare
#e=d[order(-d$score),]
#anomalylist=as.data.frame(e[c(1:100),c(1)])
g=hydroLoMST(10,b)
a$score1=g$compare
h=hydroLoMST(20,b)
a$score2=h$compare
a$avgscore=(a$score+a$score1+a$score2)/3
e=a[order(-a$avgscore),]
anomalylist=as.data.frame(e[c(1:100),c(1)])

#LOF
library(dbscan)
d=as.data.frame(a[,c(1)])
d$score=lof(b,k=10)
d$score2=lof(b,k=15)
d$score3=lof(b,k=20)
d$avgscore=(d$score+d$score2+d$score3)/3
k=d[order(-d$avgscore),]
anomalylistlof=as.data.frame(k[c(1:100),c(1)])

#SOD
library(HighDimOut)
x=Func.SOD(b, 15, 10, alpha = 0.8)
d$SODscore=x
l=d[order(-d$SODscore),]
anomalylistsod=as.data.frame(l[c(1:100),c(1)])

Anomalycompilation=as.data.frame(c(anomalylist,anomalylistlof,anomalylistsod))
colnames(Anomalycompilation)=c("LoMST","LOF", "SOD")
library(dplyr)
intersect(Anomalycompilation$LoMST,Anomalycompilation$LOF)
Reduce(intersect, list(Anomalycompilation$LoMST,Anomalycompilation$LOF,Anomalycompilation$SOD))
#write.csv(Anomalycompilation,"day.csv")
Top30=Anomalycompilation[c(1:30),]
Reduce(intersect, list(Top30$LOF,Top30$SOD))
