#Generate Table IV Column 2 (Result of our LoMST Approach for best K), other approaches result is obtained using their best k from Zimek et al. (2015)

library(fossil)
library(dbscan)
library(dplyr)
source('./Codes/LoMST.r')
LoMST_BestK = matrix(0, nrow = 20, ncol = 1) 
#Loading data file 
dat=read.csv("./Datasets/WBC.csv",header=F) #Demonstrated for WBC dataset
dat=dat[!duplicated(dat), ]
data=dat[-c(ncol(dat))]
#bestk=BestK(data,dat) #'k' value that returns the best detection performance, selected after trying all of the k-value options from 1-200
#selectedk=43 #Selected visually, we get it using PracticalKvalueselection.R, demonstrated using WBC
N=as.data.frame(table(dat[,ncol(dat)]))[2,2] #Cut-off value to evaluate the performance which is set to number of true anomalies for each dataset
#Generating the number of true detection for 'best k' determined using BestK.r"
LoMST_BestK[1,1]=LoMST (27, N)[[2]]

dat=read.csv("./Datasets/Waveform.csv",header=F) #Demonstrated for WBC dataset
dat=dat[!duplicated(dat), ]
data=dat[-c(ncol(dat))]
#bestk=BestK(data,dat) #'k' value that returns the best detection performance, selected after trying all of the k-value options from 1-200
#selectedk=43 #Selected visually, we get it using PracticalKvalueselection.R, demonstrated using WBC
N=as.data.frame(table(dat[,ncol(dat)]))[2,2] #Cut-off value to evaluate the performance which is set to number of true anomalies for each dataset
#Generating the number of true detection for 'best k' determined using BestK.r"
LoMST_BestK[2,1]=LoMST (114, N)[[2]]

dat=read.csv("./Datasets/heart.csv",header=F) #Demonstrated for WBC dataset
dat=dat[!duplicated(dat), ]
data=dat[-c(ncol(dat))]
#bestk=BestK(data,dat) #'k' value that returns the best detection performance, selected after trying all of the k-value options from 1-200
#selectedk=43 #Selected visually, we get it using PracticalKvalueselection.R, demonstrated using WBC
N=as.data.frame(table(dat[,ncol(dat)]))[2,2] #Cut-off value to evaluate the performance which is set to number of true anomalies for each dataset
#Generating the number of true detection for 'best k' determined using BestK.r"
LoMST_BestK[3,1]=LoMST (36, N)[[2]]

dat=read.csv("./Datasets/WDBC.csv",header=F) #Demonstrated for WBC dataset
dat=dat[!duplicated(dat), ]
data=dat[-c(ncol(dat))]
#bestk=BestK(data,dat) #'k' value that returns the best detection performance, selected after trying all of the k-value options from 1-200
#selectedk=43 #Selected visually, we get it using PracticalKvalueselection.R, demonstrated using WBC
N=as.data.frame(table(dat[,ncol(dat)]))[2,2] #Cut-off value to evaluate the performance which is set to number of true anomalies for each dataset
#Generating the number of true detection for 'best k' determined using BestK.r"
LoMST_BestK[4,1]=LoMST (24, N)[[2]]

dat=read.csv("./Datasets/glass.csv",header=F) #Demonstrated for WBC dataset
dat=dat[!duplicated(dat), ]
data=dat[-c(ncol(dat))]
#bestk=BestK(data,dat) #'k' value that returns the best detection performance, selected after trying all of the k-value options from 1-200
#selectedk=43 #Selected visually, we get it using PracticalKvalueselection.R, demonstrated using WBC
N=as.data.frame(table(dat[,ncol(dat)]))[2,2] #Cut-off value to evaluate the performance which is set to number of true anomalies for each dataset
#Generating the number of true detection for 'best k' determined using BestK.r"
LoMST_BestK[5,1]=LoMST (9, N)[[2]]

dat=read.csv("./Datasets/spambase.csv",header=F) #Demonstrated for WBC dataset
dat=dat[!duplicated(dat), ]
data=dat[-c(ncol(dat))]
#bestk=BestK(data,dat) #'k' value that returns the best detection performance, selected after trying all of the k-value options from 1-200
#selectedk=43 #Selected visually, we get it using PracticalKvalueselection.R, demonstrated using WBC
N=as.data.frame(table(dat[,ncol(dat)]))[2,2] #Cut-off value to evaluate the performance which is set to number of true anomalies for each dataset
#Generating the number of true detection for 'best k' determined using BestK.r"
LoMST_BestK[6,1]=LoMST (44, N)[[2]]

dat=read.csv("./Datasets/WPBC.csv",header=F) #Demonstrated for WBC dataset
dat=dat[!duplicated(dat), ]
data=dat[-c(ncol(dat))]
#bestk=BestK(data,dat) #'k' value that returns the best detection performance, selected after trying all of the k-value options from 1-200
#selectedk=43 #Selected visually, we get it using PracticalKvalueselection.R, demonstrated using WBC
N=as.data.frame(table(dat[,ncol(dat)]))[2,2] #Cut-off value to evaluate the performance which is set to number of true anomalies for each dataset
#Generating the number of true detection for 'best k' determined using BestK.r"
LoMST_BestK[7,1]=LoMST (169, N)[[2]]

dat=read.csv("./Datasets/stamps.csv",header=F) #Demonstrated for WBC dataset
dat=dat[!duplicated(dat), ]
data=dat[-c(ncol(dat))]
#bestk=BestK(data,dat) #'k' value that returns the best detection performance, selected after trying all of the k-value options from 1-200
#selectedk=43 #Selected visually, we get it using PracticalKvalueselection.R, demonstrated using WBC
N=as.data.frame(table(dat[,ncol(dat)]))[2,2] #Cut-off value to evaluate the performance which is set to number of true anomalies for each dataset
#Generating the number of true detection for 'best k' determined using BestK.r"
LoMST_BestK[8,1]=LoMST (193, N)[[2]]

dat=read.csv("./Datasets/parkinson.csv",header=F) #Demonstrated for WBC dataset
dat=dat[!duplicated(dat), ]
data=dat[-c(ncol(dat))]
#bestk=BestK(data,dat) #'k' value that returns the best detection performance, selected after trying all of the k-value options from 1-200
#selectedk=43 #Selected visually, we get it using PracticalKvalueselection.R, demonstrated using WBC
N=as.data.frame(table(dat[,ncol(dat)]))[2,2] #Cut-off value to evaluate the performance which is set to number of true anomalies for each dataset
#Generating the number of true detection for 'best k' determined using BestK.r"
LoMST_BestK[9,1]=LoMST (5, N)[[2]]

dat=read.csv("./Datasets/lymph2.csv",header=F) #Demonstrated for WBC dataset
dat=dat[!duplicated(dat), ]
data=dat[-c(ncol(dat))]
#bestk=BestK(data,dat) #'k' value that returns the best detection performance, selected after trying all of the k-value options from 1-200
#selectedk=43 #Selected visually, we get it using PracticalKvalueselection.R, demonstrated using WBC
N=as.data.frame(table(dat[,ncol(dat)]))[2,2] #Cut-off value to evaluate the performance which is set to number of true anomalies for each dataset
#Generating the number of true detection for 'best k' determined using BestK.r"
LoMST_BestK[10,1]=LoMST (13, N)[[2]]

dat=read.csv("./Datasets/ionosphere.csv",header=F) #Demonstrated for WBC dataset
dat=dat[!duplicated(dat), ]
data=dat[-c(ncol(dat))]
#bestk=BestK(data,dat) #'k' value that returns the best detection performance, selected after trying all of the k-value options from 1-200
#selectedk=43 #Selected visually, we get it using PracticalKvalueselection.R, demonstrated using WBC
N=as.data.frame(table(dat[,ncol(dat)]))[2,2] #Cut-off value to evaluate the performance which is set to number of true anomalies for each dataset
#Generating the number of true detection for 'best k' determined using BestK.r"
LoMST_BestK[11,1]=LoMST (3, N)[[2]]

dat=read.csv("./Datasets/pima.csv",header=F) #Demonstrated for WBC dataset
dat=dat[!duplicated(dat), ]
data=dat[-c(ncol(dat))]
#bestk=BestK(data,dat) #'k' value that returns the best detection performance, selected after trying all of the k-value options from 1-200
#selectedk=43 #Selected visually, we get it using PracticalKvalueselection.R, demonstrated using WBC
N=as.data.frame(table(dat[,ncol(dat)]))[2,2] #Cut-off value to evaluate the performance which is set to number of true anomalies for each dataset
#Generating the number of true detection for 'best k' determined using BestK.r"
LoMST_BestK[12,1]=LoMST (78, N)[[2]]

dat=read.csv("./Datasets/shuttle.csv",header=F) #Demonstrated for WBC dataset
dat=dat[!duplicated(dat), ]
data=dat[-c(ncol(dat))]
#bestk=BestK(data,dat) #'k' value that returns the best detection performance, selected after trying all of the k-value options from 1-200
#selectedk=43 #Selected visually, we get it using PracticalKvalueselection.R, demonstrated using WBC
N=as.data.frame(table(dat[,ncol(dat)]))[2,2] #Cut-off value to evaluate the performance which is set to number of true anomalies for each dataset
#Generating the number of true detection for 'best k' determined using BestK.r"
LoMST_BestK[13,1]=LoMST (9, N)[[2]]

dat=read.csv("./Datasets/cardioto.csv",header=F) #Demonstrated for WBC dataset
dat=dat[!duplicated(dat), ]
data=dat[-c(ncol(dat))]
#bestk=BestK(data,dat) #'k' value that returns the best detection performance, selected after trying all of the k-value options from 1-200
#selectedk=43 #Selected visually, we get it using PracticalKvalueselection.R, demonstrated using WBC
N=as.data.frame(table(dat[,ncol(dat)]))[2,2] #Cut-off value to evaluate the performance which is set to number of true anomalies for each dataset
#Generating the number of true detection for 'best k' determined using BestK.r"
LoMST_BestK[14,1]=LoMST (46, N)[[2]]

dat=read.csv("./Datasets/arrh.csv",header=F) #Demonstrated for WBC dataset
dat=dat[!duplicated(dat), ]
data=dat[-c(ncol(dat))]
#bestk=BestK(data,dat) #'k' value that returns the best detection performance, selected after trying all of the k-value options from 1-200
#selectedk=43 #Selected visually, we get it using PracticalKvalueselection.R, demonstrated using WBC
N=as.data.frame(table(dat[,ncol(dat)]))[2,2] #Cut-off value to evaluate the performance which is set to number of true anomalies for each dataset
#Generating the number of true detection for 'best k' determined using BestK.r"
LoMST_BestK[15,1]=LoMST (28, N)[[2]]

dat=read.csv("./Datasets/Pblock.csv",header=F) #Demonstrated for WBC dataset
dat=dat[!duplicated(dat), ]
data=dat[-c(ncol(dat))]
#bestk=BestK(data,dat) #'k' value that returns the best detection performance, selected after trying all of the k-value options from 1-200
#selectedk=43 #Selected visually, we get it using PracticalKvalueselection.R, demonstrated using WBC
N=as.data.frame(table(dat[,ncol(dat)]))[2,2] #Cut-off value to evaluate the performance which is set to number of true anomalies for each dataset
#Generating the number of true detection for 'best k' determined using BestK.r"
LoMST_BestK[16,1]=LoMST (8, N)[[2]]

dat=read.csv("./Datasets/pendigits.csv",header=F) #Demonstrated for WBC dataset
dat=dat[!duplicated(dat), ]
data=dat[-c(ncol(dat))]
#bestk=BestK(data,dat) #'k' value that returns the best detection performance, selected after trying all of the k-value options from 1-200
#selectedk=43 #Selected visually, we get it using PracticalKvalueselection.R, demonstrated using WBC
N=as.data.frame(table(dat[,ncol(dat)]))[2,2] #Cut-off value to evaluate the performance which is set to number of true anomalies for each dataset
#Generating the number of true detection for 'best k' determined using BestK.r"
LoMST_BestK[17,1]=LoMST (46, N)[[2]]

dat=read.csv("./Datasets/kdd.csv",header=F) #Demonstrated for WBC dataset
dat=dat[!duplicated(dat), ]
data=dat[-c(ncol(dat))]
#bestk=BestK(data,dat) #'k' value that returns the best detection performance, selected after trying all of the k-value options from 1-200
#selectedk=43 #Selected visually, we get it using PracticalKvalueselection.R, demonstrated using WBC
N=as.data.frame(table(dat[,ncol(dat)]))[2,2] #Cut-off value to evaluate the performance which is set to number of true anomalies for each dataset
#Generating the number of true detection for 'best k' determined using BestK.r"
LoMST_BestK[18,1]=LoMST (76, N)[[2]]


dat=read.csv("./Datasets/aloi.csv",header=F) #Demonstrated for WBC dataset
dat=dat[!duplicated(dat), ]
data=dat[-c(ncol(dat))]
#bestk=BestK(data,dat) #'k' value that returns the best detection performance, selected after trying all of the k-value options from 1-200
#selectedk=43 #Selected visually, we get it using PracticalKvalueselection.R, demonstrated using WBC
N=as.data.frame(table(dat[,ncol(dat)]))[2,2] #Cut-off value to evaluate the performance which is set to number of true anomalies for each dataset
#Generating the number of true detection for 'best k' determined using BestK.r"
LoMST_BestK[19,1]=LoMST (3, N)[[2]]

dat=read.csv("./Datasets/annthyroid.csv",header=F) #Demonstrated for WBC dataset
dat=dat[!duplicated(dat), ]
data=dat[-c(ncol(dat))]
#bestk=BestK(data,dat) #'k' value that returns the best detection performance, selected after trying all of the k-value options from 1-200
#selectedk=43 #Selected visually, we get it using PracticalKvalueselection.R, demonstrated using WBC
N=as.data.frame(table(dat[,ncol(dat)]))[2,2] #Cut-off value to evaluate the performance which is set to number of true anomalies for each dataset
#Generating the number of true detection for 'best k' determined using BestK.r"
LoMST_BestK[20,1]=LoMST (5, N)[[2]]

