#This R Code will generate a table containing the LoMST detections for all 20 datasets using Practial K
#Then it will generate Generate Table IV Row 5 

library(fossil)
library(dbscan)
library(dplyr)
source('./Codes/LoMST.r')
LoMST_PracticalK = matrix(0, nrow = 20, ncol = 1) 
#Loading data file 
dat=read.csv("./Datasets/WBC.csv",header=F) #Demonstrated for WBC dataset
dat=dat[!duplicated(dat), ]
data=dat[-c(ncol(dat))]
N=as.data.frame(table(dat[,ncol(dat)]))[2,2] #Cut-off value to evaluate the performance which is set to number of true anomalies for each dataset
#Generating the number of true detection for 'practical k' determined using PracticalKSelection.r"
LoMST_PracticalK[1,1]=LoMST (43, N)[[2]]

dat=read.csv("./Datasets/Waveform.csv",header=F) #Demonstrated for WBC dataset
dat=dat[!duplicated(dat), ]
data=dat[-c(ncol(dat))]
N=as.data.frame(table(dat[,ncol(dat)]))[2,2] #Cut-off value to evaluate the performance which is set to number of true anomalies for each dataset
#Generating the number of true detection for 'practical k' determined using PracticalKSelection.r"
LoMST_PracticalK[2,1]=LoMST (69, N)[[2]]

dat=read.csv("./Datasets/heart.csv",header=F) #Demonstrated for WBC dataset
dat=dat[!duplicated(dat), ]
data=dat[-c(ncol(dat))]
N=as.data.frame(table(dat[,ncol(dat)]))[2,2] #Cut-off value to evaluate the performance which is set to number of true anomalies for each dataset
#Generating the number of true detection for 'practical k' determined using PracticalKSelection.r"
LoMST_PracticalK[3,1]=LoMST (63, N)[[2]]

dat=read.csv("./Datasets/WDBC.csv",header=F) #Demonstrated for WBC dataset
dat=dat[!duplicated(dat), ]
data=dat[-c(ncol(dat))]
N=as.data.frame(table(dat[,ncol(dat)]))[2,2] #Cut-off value to evaluate the performance which is set to number of true anomalies for each dataset
#Generating the number of true detection for 'practical k' determined using PracticalKSelection.r"
LoMST_PracticalK[4,1]=LoMST (33, N)[[2]]

dat=read.csv("./Datasets/glass.csv",header=F) #Demonstrated for WBC dataset
dat=dat[!duplicated(dat), ]
data=dat[-c(ncol(dat))]
N=as.data.frame(table(dat[,ncol(dat)]))[2,2] #Cut-off value to evaluate the performance which is set to number of true anomalies for each dataset
#Generating the number of true detection for 'practical k' determined using PracticalKSelection.r"
LoMST_PracticalK[5,1]=LoMST (9, N)[[2]]

dat=read.csv("./Datasets/spambase.csv",header=F) #Demonstrated for WBC dataset
dat=dat[!duplicated(dat), ]
data=dat[-c(ncol(dat))]
N=as.data.frame(table(dat[,ncol(dat)]))[2,2] #Cut-off value to evaluate the performance which is set to number of true anomalies for each dataset
#Generating the number of true detection for 'practical k' determined using PracticalKSelection.r"
LoMST_PracticalK[6,1]=LoMST (34, N)[[2]]

dat=read.csv("./Datasets/WPBC.csv",header=F) #Demonstrated for WBC dataset
dat=dat[!duplicated(dat), ]
data=dat[-c(ncol(dat))]
N=as.data.frame(table(dat[,ncol(dat)]))[2,2] #Cut-off value to evaluate the performance which is set to number of true anomalies for each dataset
#Generating the number of true detection for 'practical k' determined using PracticalKSelection.r"
LoMST_PracticalK[7,1]=LoMST (44, N)[[2]]

dat=read.csv("./Datasets/stamps.csv",header=F) #Demonstrated for WBC dataset
dat=dat[!duplicated(dat), ]
data=dat[-c(ncol(dat))]
N=as.data.frame(table(dat[,ncol(dat)]))[2,2] #Cut-off value to evaluate the performance which is set to number of true anomalies for each dataset
#Generating the number of true detection for 'practical k' determined using PracticalKSelection.r"
LoMST_PracticalK[8,1]=LoMST (60, N)[[2]]

dat=read.csv("./Datasets/parkinson.csv",header=F) #Demonstrated for WBC dataset
dat=dat[!duplicated(dat), ]
data=dat[-c(ncol(dat))]
N=as.data.frame(table(dat[,ncol(dat)]))[2,2] #Cut-off value to evaluate the performance which is set to number of true anomalies for each dataset
#Generating the number of true detection for 'practical k' determined using PracticalKSelection.r"
LoMST_PracticalK[9,1]=LoMST (40, N)[[2]]

dat=read.csv("./Datasets/lymph2.csv",header=F) #Demonstrated for WBC dataset
dat=dat[!duplicated(dat), ]
data=dat[-c(ncol(dat))]
N=as.data.frame(table(dat[,ncol(dat)]))[2,2] #Cut-off value to evaluate the performance which is set to number of true anomalies for each dataset
#Generating the number of true detection for 'practical k' determined using PracticalKSelection.r"
LoMST_PracticalK[10,1]=LoMST (28, N)[[2]]

dat=read.csv("./Datasets/ionosphere.csv",header=F) #Demonstrated for WBC dataset
dat=dat[!duplicated(dat), ]
data=dat[-c(ncol(dat))]
N=as.data.frame(table(dat[,ncol(dat)]))[2,2] #Cut-off value to evaluate the performance which is set to number of true anomalies for each dataset
#Generating the number of true detection for 'practical k' determined using PracticalKSelection.r"
LoMST_PracticalK[11,1]=LoMST (12, N)[[2]]

dat=read.csv("./Datasets/pima.csv",header=F) #Demonstrated for WBC dataset
dat=dat[!duplicated(dat), ]
data=dat[-c(ncol(dat))]
N=as.data.frame(table(dat[,ncol(dat)]))[2,2] #Cut-off value to evaluate the performance which is set to number of true anomalies for each dataset
#Generating the number of true detection for 'practical k' determined using PracticalKSelection.r"
LoMST_PracticalK[12,1]=LoMST (81, N)[[2]]

dat=read.csv("./Datasets/shuttle.csv",header=F) #Demonstrated for WBC dataset
dat=dat[!duplicated(dat), ]
data=dat[-c(ncol(dat))]
N=as.data.frame(table(dat[,ncol(dat)]))[2,2] #Cut-off value to evaluate the performance which is set to number of true anomalies for each dataset
#Generating the number of true detection for 'practical k' determined using PracticalKSelection.r"
LoMST_PracticalK[13,1]=LoMST (8, N)[[2]]

dat=read.csv("./Datasets/cardioto.csv",header=F) #Demonstrated for WBC dataset
dat=dat[!duplicated(dat), ]
data=dat[-c(ncol(dat))]
N=as.data.frame(table(dat[,ncol(dat)]))[2,2] #Cut-off value to evaluate the performance which is set to number of true anomalies for each dataset
#Generating the number of true detection for 'practical k' determined using PracticalKSelection.r"
LoMST_PracticalK[14,1]=LoMST (36, N)[[2]]

dat=read.csv("./Datasets/arrh.csv",header=F) #Demonstrated for WBC dataset
dat=dat[!duplicated(dat), ]
data=dat[-c(ncol(dat))]
N=as.data.frame(table(dat[,ncol(dat)]))[2,2] #Cut-off value to evaluate the performance which is set to number of true anomalies for each dataset
#Generating the number of true detection for 'practical k' determined using PracticalKSelection.r"
LoMST_PracticalK[15,1]=LoMST (24, N)[[2]]

dat=read.csv("./Datasets/Pblock.csv",header=F) #Demonstrated for WBC dataset
dat=dat[!duplicated(dat), ]
data=dat[-c(ncol(dat))]
N=as.data.frame(table(dat[,ncol(dat)]))[2,2] #Cut-off value to evaluate the performance which is set to number of true anomalies for each dataset
#Generating the number of true detection for 'practical k' determined using PracticalKSelection.r"
LoMST_PracticalK[16,1]=LoMST (48, N)[[2]]

dat=read.csv("./Datasets/pendigits.csv",header=F) #Demonstrated for WBC dataset
dat=dat[!duplicated(dat), ]
data=dat[-c(ncol(dat))]
N=as.data.frame(table(dat[,ncol(dat)]))[2,2] #Cut-off value to evaluate the performance which is set to number of true anomalies for each dataset
#Generating the number of true detection for 'practical k' determined using PracticalKSelection.r"
LoMST_PracticalK[17,1]=LoMST (79, N)[[2]]

dat=read.csv("./Datasets/kdd.csv",header=F) #Demonstrated for WBC dataset
dat=dat[!duplicated(dat), ]
data=dat[-c(ncol(dat))]
N=as.data.frame(table(dat[,ncol(dat)]))[2,2] #Cut-off value to evaluate the performance which is set to number of true anomalies for each dataset
#Generating the number of true detection for 'practical k' determined using PracticalKSelection.r"
LoMST_PracticalK[18,1]=LoMST (78, N)[[2]]


dat=read.csv("./Datasets/aloi.csv",header=F) #Demonstrated for WBC dataset
dat=dat[!duplicated(dat), ]
data=dat[-c(ncol(dat))]
N=as.data.frame(table(dat[,ncol(dat)]))[2,2] #Cut-off value to evaluate the performance which is set to number of true anomalies for each dataset
#Generating the number of true detection for 'practical k' determined using PracticalKSelection.r"
LoMST_PracticalK[19,1]=LoMST (45, N)[[2]]

dat=read.csv("./Datasets/annthyroid.csv",header=F) #Demonstrated for WBC dataset
dat=dat[!duplicated(dat), ]
data=dat[-c(ncol(dat))]
N=as.data.frame(table(dat[,ncol(dat)]))[2,2] #Cut-off value to evaluate the performance which is set to number of true anomalies for each dataset
#Generating the number of true detection for 'practical k' determined using PracticalKSelection.r"
LoMST_PracticalK[20,1]=LoMST (65, N)[[2]]
library(PMCMR)
library(matrixStats)
#Loading Detection of all approaches using practical K
b=read.csv("./Datasets/Practical K original counts.csv")
d=rowRanks(-as.matrix(b), ties.method = c("min"))
AverageRank=round(colMeans(d),1)
AverageRank

