#Following function implements the LoMST algorithm for the hydropower plant data

hydroLoMST=function(selectedk,data){
  nn <- kNN(data, k=selectedk)
  kn=as.matrix(nn$id)
  
  for(i in 1:nrow(data)) 
  { 
    nam<- paste("dist", i, sep = "")
    assign(nam, as.matrix(dist(data[c(i,kn[i,]),])))
  }
  
  sumhist=numeric(nrow(data))
  compare=numeric(nrow(data))
  for(i in 1:nrow(data)){
    d=get(paste("dist", i, sep = ""))
    mat=as.matrix(dino.mst(d))
    d[which(mat== 0)] <- 0
    
    sumhist[i]=sum(d)}
  for(i in 1:nrow(data)){
    compare[i]=sumhist[i]-mean(sumhist[c(kn[i,])])}
  
  summary=as.data.frame(compare)
  summary$obs=c(1:nrow(data))
  sumhistarranged=as.data.frame(arrange(summary,desc(compare)))
return(as.data.frame(summary))}