#Generate Column 6, 7 of the Table VIII of the paper

library(PMCMR)
library(matrixStats)
#Loading Detection of all approaches using Best K
a=read.csv("./Datasets/Best K original counts.csv")
d=rowRanks(-as.matrix(a), ties.method = c("min"))
b=read.csv("./Datasets/Practical K original counts.csv")
e=rowRanks(-as.matrix(b), ties.method = c("min"))
finalrankoutcome=as.data.frame(cbind(d[,1],e[,1]))
colnames(finalrankoutcome)[1]="Rank(BestK)"
colnames(finalrankoutcome)[2]="Rank(PracticalK)"
finalrankoutcome$Dataset=c('WBC',    'Waveform',    'Heart',    'WDBC',    'Glass',    'Spambase',    'WPBC',    'Stamps',    'Parkinson',    'Lymphography', 'Ionosphere',  'PIMA',  'Shuttle',  'Cardiotocograpghy', 'Arrhythmia',  'Pageblocks','Pendigits', 'KDD', 'ALOI',  'Annthyroid')